#This builds and test a two state FSA.  It calls the test functions
#in the FSAClass.  It should have the same results as testFSA.py.
#state 0 and input 1 turns on state 2.  2 turns off 1 and 0.

import nealParams as nealParameters
#get the simulator
if  (nealParameters.simulator=="spinnaker"):
    import pyNN.spiNNaker as sim
elif (nealParameters.simulator=="nest"):
    import pyNN.nest as sim
    import cPickle as pickle
import numpy as np

from nealCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions

#---Below here are functions to test the system---
RUN_DURATION = 200

##--main---
neal = NealCoverFunctions(nealParameters.simulator)
fsa = FSAHelperFunctions(nealParameters.simulator)

fsa.testInit()

#setup input
spikeGenerators = fsa.testCreateTwoInputs()
firstSpikeGenerator =  spikeGenerators[0]
secondSpikeGenerator =  spikeGenerators[1]

#make neurons and make them recordable
stateCells = fsa.testCreateNeurons()
fsa.testSetupRecording(stateCells)

#build the fsa and run it
fsa.test3StateFSA(firstSpikeGenerator,secondSpikeGenerator,stateCells)
fsa.testRunFSA(RUN_DURATION)

#print results
fsa.testPrintResults(stateCells)



